/* tslint:disable */
/* eslint-disable */
/**
 * receipts.v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface ContactData
 */
export interface ContactData {
    /**
     * 
     * @type {string}
     * @memberof ContactData
     */
    contact_id: string;
    /**
     * 
     * @type {string}
     * @memberof ContactData
     */
    channel_id: string;
    /**
     * 
     * @type {string}
     * @memberof ContactData
     */
    gateway_id: string;
    /**
     * 
     * @type {string}
     * @memberof ContactData
     */
    conversation_id: string;
}
/**
 * 
 * @export
 * @interface ReceiptDownloadRequest
 */
export interface ReceiptDownloadRequest {
    /**
     * 
     * @type {string}
     * @memberof ReceiptDownloadRequest
     */
    transaction_id: string;
    /**
     * 
     * @type {string}
     * @memberof ReceiptDownloadRequest
     */
    receipt_id: string;
    /**
     * 
     * @type {ContactData}
     * @memberof ReceiptDownloadRequest
     */
    contact: ContactData;
}
/**
 * 
 * @export
 * @interface ReceiptDownloadResponse
 */
export interface ReceiptDownloadResponse {
    /**
     * 
     * @type {string}
     * @memberof ReceiptDownloadResponse
     */
    id?: string;
    /**
     * 
     * @type {string}
     * @memberof ReceiptDownloadResponse
     */
    external_receipt_id?: string;
    /**
     * 
     * @type {string}
     * @memberof ReceiptDownloadResponse
     */
    file_url?: string;
    /**
     * 
     * @type {string}
     * @memberof ReceiptDownloadResponse
     */
    status?: string;
}
/**
 * 
 * @export
 * @interface ReceiptDownloadStatusResponse
 */
export interface ReceiptDownloadStatusResponse {
    /**
     * 
     * @type {string}
     * @memberof ReceiptDownloadStatusResponse
     */
    id: string;
    /**
     * 
     * @type {string}
     * @memberof ReceiptDownloadStatusResponse
     */
    status?: ReceiptDownloadStatusResponseStatusEnum;
}

/**
    * @export
    * @enum {string}
    */
export enum ReceiptDownloadStatusResponseStatusEnum {
    Draft = 'draft'
}


/**
 * ReceiptsApi - axios parameter creator
 * @export
 */
export const ReceiptsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Create receipt and start download task in background
         * @summary Create Anybill receipt download task
         * @param {ReceiptDownloadRequest} [receiptDownloadRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createAnybillReceipt: async (receiptDownloadRequest?: ReceiptDownloadRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/anybill/receipts`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(receiptDownloadRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Trigger download task
         * @summary Download Anybill receipt pdf
         * @param {object} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        downloadAnybillReceipt: async (body?: object, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/anybill/receipts/:id/download`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(body, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ReceiptsApi - functional programming interface
 * @export
 */
export const ReceiptsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ReceiptsApiAxiosParamCreator(configuration)
    return {
        /**
         * Create receipt and start download task in background
         * @summary Create Anybill receipt download task
         * @param {ReceiptDownloadRequest} [receiptDownloadRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createAnybillReceipt(receiptDownloadRequest?: ReceiptDownloadRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ReceiptDownloadStatusResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createAnybillReceipt(receiptDownloadRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Trigger download task
         * @summary Download Anybill receipt pdf
         * @param {object} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async downloadAnybillReceipt(body?: object, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ReceiptDownloadResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.downloadAnybillReceipt(body, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * ReceiptsApi - factory interface
 * @export
 */
export const ReceiptsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ReceiptsApiFp(configuration)
    return {
        /**
         * Create receipt and start download task in background
         * @summary Create Anybill receipt download task
         * @param {ReceiptDownloadRequest} [receiptDownloadRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createAnybillReceipt(receiptDownloadRequest?: ReceiptDownloadRequest, options?: any): AxiosPromise<ReceiptDownloadStatusResponse> {
            return localVarFp.createAnybillReceipt(receiptDownloadRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * Trigger download task
         * @summary Download Anybill receipt pdf
         * @param {object} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        downloadAnybillReceipt(body?: object, options?: any): AxiosPromise<ReceiptDownloadResponse> {
            return localVarFp.downloadAnybillReceipt(body, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * ReceiptsApi - object-oriented interface
 * @export
 * @class ReceiptsApi
 * @extends {BaseAPI}
 */
export class ReceiptsApi extends BaseAPI {
    /**
     * Create receipt and start download task in background
     * @summary Create Anybill receipt download task
     * @param {ReceiptDownloadRequest} [receiptDownloadRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReceiptsApi
     */
    public createAnybillReceipt(receiptDownloadRequest?: ReceiptDownloadRequest, options?: any) {
        return ReceiptsApiFp(this.configuration).createAnybillReceipt(receiptDownloadRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Trigger download task
     * @summary Download Anybill receipt pdf
     * @param {object} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReceiptsApi
     */
    public downloadAnybillReceipt(body?: object, options?: any) {
        return ReceiptsApiFp(this.configuration).downloadAnybillReceipt(body, options).then((request) => request(this.axios, this.basePath));
    }
}


